var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { requestTypes, requestCount, requestPage } from "./request";
class Collecter {
  constructor(url, params = {}) {
    __publicField(this, "url", "");
    __publicField(this, "pg", 1);
    __publicField(this, "pageCount", -1);
    __publicField(this, "recordCount", -1);
    __publicField(this, "params");
    __publicField(this, "types", async () => await requestTypes(this.url));
    this.url = url;
    this.params = params;
  }
  reset() {
    this.pg = 1;
    this.pageCount = -1;
    this.recordCount = -1;
  }
  async nextPage() {
    if (this.pageCount === -1) {
      const { pageCount, recordCount } = await requestCount(this.url, this.params);
      this.recordCount = recordCount;
      this.pageCount = pageCount;
    }
    if (this.pg <= this.pageCount) {
      const videos = await requestPage(this.url, this.pg, this.params);
      this.pg++;
      return videos;
    }
    this.reset();
    return null;
  }
  [Symbol.iterator]() {
    return this;
  }
  async next() {
    const value = this.nextPage();
    return { done: value === null, value };
  }
}
export {
  Collecter as default
};
